var ios = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
var cookieUri = ios.newURI(SERVER, null, null);
var cookieSvc = Components.classes["@mozilla.org/cookieService;1"].getService(Components.interfaces.nsICookieService);

//*****************************
// Set cookies for 1000 days
//*****************************
function setCookies()
{
    doCookies(1000);
}

//*****************************
// Erase cookies (set for -1000 days)
//*****************************
function eraseCookies()
{
    doCookies(-1000);
}

//*****************************
// Set the 2 cookies
// g_sc_userUID
// g_sc_sessionUID
// for the SERVER variable uri on spreadcrumbs.js
//*****************************
function doCookies(days)
{
    try
    {
        var expiredays = days;
        var exdate=new Date();
        exdate.setDate(exdate.getDate()+expiredays);
        
        cookie = "";        
        
        writeCookie("g_sc_userUID", g_sc_userUID, ";");
        writeCookie("expires",exdate.toGMTString(), ";"); 
        cookieSvc.setCookieString(cookieUri, null, cookie, null);
        
        cookie = "";
        writeCookie("g_sc_sessionUID", g_sc_sessionUID, ";");
        writeCookie("expires",exdate.toGMTString(), ";");          
        cookieSvc.setCookieString(cookieUri, null, cookie, null);
        
        getCookies(); 
    }
    catch(error)
    {
        alert(error);
    }
    
}

//*****************************
// Read the 2 cookies and set the global variables defined in spreadcrumbs.js
// g_sc_userUID
// g_sc_sessionUID
//*****************************
function getCookies()
{
    try{
        var mainWindow = window.QueryInterface(Components.interfaces.nsIInterfaceRequestor)
                           .getInterface(Components.interfaces.nsIWebNavigation)
                           .QueryInterface(Components.interfaces.nsIDocShellTreeItem)
                           .rootTreeItem
                           .QueryInterface(Components.interfaces.nsIInterfaceRequestor)
                           .getInterface(Components.interfaces.nsIDOMWindow);
                               
        cookie = cookieSvc.getCookieString(cookieUri, null);
        
        g_sc_userUID = readCookie("g_sc_userUID", ";");
        g_sc_sessionUID = readCookie("g_sc_sessionUID", ";");
       
        
        mainWindow.g_sc_userUID = g_sc_userUID;
        mainWindow.g_sc_sessionUID = g_sc_sessionUID;
        
        if(g_sc_userUID && g_sc_sessionUID)
        {
            SpreadCrumbsOnOff = true;
            mainWindow.SpreadCrumbsOnOff = true;
        }
    }
    catch(error)
    {
        alert(error);
    }
}

//*****************************
// Write a single cookie with a delimiter
// on the local variable cookie
//*****************************
function writeCookie(name,value,delimit)
{
    var B4,Af,fC,lC;
    var mcookie = unescape(cookie);
    var ncookie;
    fC = mcookie.indexOf(name);
    var ph = fC + name.length;
    if ((fC != -1) && (mcookie.charAt(ph) == '='))
    {
      B4 = mcookie.substring(0,fC);
      fC += name.length + 1;
      lC = mcookie.indexOf(delimit,fC);
      if (lC == -1) lC = mcookie.length;
      if (lC == mcookie.length)
      {
        ncookie = B4 + name + "=" + value;
        cookie = escape(ncookie);
        return true;
      }
      else
      {   
        Af = mcookie.substring(lC,mcookie.length);
        ncookie = B4 + name + "=" + value + Af;
        cookie = escape(ncookie);
        return true;
      }   
    }
    else
    {
      if(mcookie!="")
        ncookie = mcookie + delimit + name + "=" + value;
      else
        ncookie = name + "=" + value;
      
      //cookie = escape(ncookie); //this removes the ;
      
      cookie = ncookie
      return false;
    }
}   

//*****************************
// Read a single cookie with a delimiter
// from the local variable cookie
//*****************************
function readCookie(name,delimit)
{
  if (cookie == '')
  {
    return false;
  }
  else
  {
    var fC,lC;
    var mcookie = unescape(cookie);
    fC = mcookie.indexOf(name);
    var ph = fC + name.length;
    if ((fC != -1) && (mcookie.charAt(ph) == '='))
    {
      fC += name.length + 1;
      lC = mcookie.indexOf(delimit,fC);
      if (lC == -1) lC = mcookie.length;
      return unescape(mcookie.substring(fC,lC));
    }
    else
    {
      return false;
    }
  }
}