var mainWindow = window.QueryInterface(Components.interfaces.nsIInterfaceRequestor)
                   .getInterface(Components.interfaces.nsIWebNavigation)
                   .QueryInterface(Components.interfaces.nsIDocShellTreeItem)
                   .rootTreeItem
                   .QueryInterface(Components.interfaces.nsIInterfaceRequestor)
                   .getInterface(Components.interfaces.nsIDOMWindow);

//*****************************
// Do the login or logout control deppending on the checkbox of the menu
//*****************************
function sc_logInOrOut()
{
    try{
        if(document.getElementById("sc_menu_login"))
        {
            if(!document.getElementById("sc_menu_login").getAttribute("checked"))
                sc_logout();
            else
                sc_openLoginDlg();
        }
        else if (document.getElementById("loginImage"))
        {
            if( document.getElementById("loginImage").getAttribute("src") == "images/green.png" )
                sc_logout();
            else
                sc_openLoginDlg();    
        }
    }
    catch(e)
    {
        alert(e);
    }
}

function hideShowLoginTab(show)
{
    var loginTab;
    var topicsTab;
    if(window.location.href == "chrome://browser/content/browser.xul")  
    {
        loginTab = document.getElementById("sidebar").contentWindow.document.getElementById("loginTabLabel");
        topicsTab = document.getElementById("sidebar").contentWindow.document.getElementById("topicsTabLabel");
    }
    else if (window.location.href == "chrome://spreadcrumbsdev/content/sc_sidebar.xul")
    {   
        loginTab = document.getElementById("loginTabLabel");
        topicsTab = document.getElementById("topicsTabLabel");
    }
    
    if(show)
    {
        refreshFrame("sc_sidebar_frame_login", "http://spreadcrumbsdev.l3s.uni-hannover.de/sidebar/spreadCrumbs_sidebar_login.php");
        loginTab.style.display="";
        loginTab.click();
    }
    else
    {
       loginTab.style.display="none";
       topicsTab.click();       
    }
}

//*****************************
// Check if user is logged (global variables are setted)
// and check the menu login checkbox
//*****************************
function sc_checkLogin()
{
    try
    { 
        g_sc_userUID = mainWindow.g_sc_userUID;
        g_sc_sessionUID = mainWindow.g_sc_sessionUID;
       
        var image = "images/red.png";
        
        if( (g_sc_userUID) &&  (g_sc_userUID!="false") && (g_sc_userUID!=null) &&  (g_sc_userUID!="null") && (g_sc_sessionUID) &&  (g_sc_sessionUID!="false") &&  (g_sc_sessionUID!=null) && (g_sc_sessionUID!="null"))
        {
            var param = "?userUID="+g_sc_userUID;
            mainWindow.makeRequest(SERVER+"/ajax/spreadCrumbs_getUserName.php", param, "getUserName", null);
    
            mainWindow.setCookies();
            image = "images/green.png";
            mainWindow.document.getElementById("sc_menu_login").setAttribute("checked", true);
            hideShowLoginTab(0);
        }
        else
        {
            mainWindow.document.getElementById("sc_menu_login").setAttribute("checked", false);
            hideShowLoginTab(1);
        }        

        if(window.location.href == "chrome://browser/content/browser.xul")  
        {
            document.getElementById("sidebar").contentWindow.g_sc_sessionUID = g_sc_sessionUID;
            document.getElementById("sidebar").contentWindow.g_sc_userUID = g_sc_userUID;
             
            document.getElementById("sidebar").contentWindow.refreshPages('all'); 
            document.getElementById("sidebar").contentWindow.document.getElementById("loginImage").src=image;
        }
        else if (window.location.href == "chrome://spreadcrumbsdev/content/sc_sidebar.xul")
        {
            refreshPages("all");
            document.getElementById("loginImage").src=image;
        }        
        
        mainWindow.prefManager.setBoolPref("extensions.SpreadCrumbs.enabled", true);     
    }
    catch(e)
    {
       //alert("sc_checkLogin: " + e);
    }
}


//*****************************
// Open the login popUp
// the popUp window calls back the sc_checkLogin() function
//*****************************
function sc_openLoginDlg()
{
    var popW = 450;
    var popH = 350;
    var w = screen.availWidth;
    var h = screen.availHeight;
    var left = (w-popW)/2;
    var top = (h-popH)/2;    
      
    //var connectWindow = window.openDialog("http://spreadcrumbs.l3s.uni-hannover.de/connect/connect.php", "Connect", "resizable=yes,width="+popW+",height="+popH+",top="+top+"px,left="+left+"px"); 
    hideShowLoginTab(true);
    //var connectWindow = window.openDialog("http://spreadcrumbsdev.l3s.uni-hannover.de/sidebar/spreadCrumbs_sidebar_login.php", "Connect", "resizable=yes,width="+popW+",height="+popH+",top="+top+"px,left="+left+"px"); 
    // var connectWindow = window.open("login.xul", "Connect", "resizable=yes,width="+popW+",height="+popH+",top="+top+"px,left="+left+"px");
    //connectWindow.focus();
    return;       
}

//*****************************
// Call the ajax login page to logout (destroy session)
// clean the global variables and checklogin
//*****************************
function sc_logout()
{
    eraseCookies();
    var loginPage=SERVER+'/ajax/spreadCrumbs_sidebar_login_ajax.php?logout=1';
    
    makeAjaxLoginRequest(loginPage, 'ajaxLogout');
    
    mainWindow.setUserName("", true);
    
    /*
    // This is prototype, but the lib is messing up with the tool tip
    // This is too bad, there's better!
    new Ajax.Request(loginPage, {
      onSuccess: function(transport) {
        g_sc_userUID = null;
        g_sc_sessionUID = null;
        sc_checkLogin();
      }
    });
    */
    
    mainWindow.prefManager.setBoolPref("extensions.SpreadCrumbs.enabled", false); 
    // this hides the bar
    //toggleSidebar();
}

//*****************************
// Call the ajax login page to login from cookies information
// only used on startup
//*****************************
function sc_ajaxLogin()
{
    try
    {
        var loginPage=SERVER+'/ajax/spreadCrumbs_sidebar_login_ajax.php?userUID='+g_sc_userUID+'&sessionUID='+g_sc_sessionUID;
         // This is too bad, there's better!
        makeAjaxLoginRequest(loginPage, 'ajaxLogin');
         
         /*
        new Ajax.Request(loginPage, {
          onSuccess: function(transport) {
                    
            var response = eval("(" + transport.responseText + ")");
            g_sc_userUID = response.userUID;
            g_sc_sessionUID = response.sessionUID;
            
            sc_checkLogin();
            
          }
        });
        */
    }
    catch(e)
    {
        alert(e);
    }
}


//*****************************
// after login always show the sideBar
// and refresh pages
//*****************************

function sc_afterLoggedIn()
{
    try
    {
        // if is not calling from the sidebar force its openning
        if(window.location.href == "chrome://browser/content/browser.xul")
        {
            toggleSidebar("sc_sidebar", true);
            var sidebarWindow = document.getElementById("sidebar").contentWindow;
        }
        
        //alert("after login g_sc_userUID:" + g_sc_userUID);
    }
    catch(e)
    {
        alert(e);          
    }
}



/***************** MY AJAX ***************/
function makeAjaxLoginRequest(url, action) {
  var http_request = false;
  
  //alert(url);
  
  if (window.XMLHttpRequest) { // Mozilla, Safari,...
     http_request = new XMLHttpRequest();
     if (http_request.overrideMimeType) {
        http_request.overrideMimeType('text/html');
     }
  } else if (window.ActiveXObject) { // IE
     try {
        http_request = new ActiveXObject("Msxml2.XMLHTTP");
     } catch (error) {
        try {
           http_request = new ActiveXObject("Microsoft.XMLHTTP");
        } catch (error) {}
     }
  }
  if (!http_request) {
    alert('SpreadCrumbs: Cannot create XMLHTTP instance');
    return false;
  }
  
  // get response from AJAX and use it depending on the action.
  http_request.onreadystatechange = function getResponse(){ useAjaxLoginResponse(http_request, action) };  
  
  try{
        http_request.open('GET', url, true);
        http_request.send(null);
    }
    catch(error)
    {
        alert("SpreadCrumbs: Server request error. \n" + error);
    }  
}

function useAjaxLoginResponse(http_request, action, caller) {
    if (http_request.readyState == 4) {
        if (http_request.status == 200) {
              result = http_request.responseText;
              
            if(action=="ajaxLogin")
            {              
                var response = eval("(" + result + ")");
                g_sc_userUID = response.userUID;
                g_sc_sessionUID = response.sessionUID;
                sc_checkLogin();
            }
            
            if(action=="ajaxLogout")
            {  
                g_sc_userUID = null;
                g_sc_sessionUID = null;
                sc_checkLogin();            
            }
            
        }
    }
    
    
}